package com.artfess.cqxy.processManagermant.manager.impl;

import cn.afterturn.easypoi.excel.ExcelExportUtil;
import cn.afterturn.easypoi.excel.ExcelImportUtil;
import cn.afterturn.easypoi.excel.entity.ExportParams;
import cn.afterturn.easypoi.excel.entity.ImportParams;
import com.artfess.base.context.BaseContext;
import com.artfess.base.feign.SystemConfigFeignService;
import com.artfess.base.manager.impl.BaseManagerImpl;
import com.artfess.base.query.PageBean;
import com.artfess.base.query.PageList;
import com.artfess.base.query.QueryFilter;
import com.artfess.base.query.QueryOP;
import com.artfess.base.util.BeanUtils;
import com.artfess.cqxy.processManagermant.dao.SecurityManageDao;
import com.artfess.cqxy.processManagermant.manager.SecurityManageManager;
import com.artfess.cqxy.processManagermant.model.SecurityManage;
import com.artfess.cqxy.projectManagement.enums.ProjectStatusEnum;
import com.artfess.cqxy.projectManagement.manager.ProjectManagementManager;
import com.artfess.cqxy.projectManagement.model.ProjectManagement;
import com.artfess.cqxy.search.enums.FunctionEnum;
import com.artfess.cqxy.search.manager.GlobalRetrievalManager;
import com.artfess.cqxy.search.model.GlobalRetrieval;
import com.artfess.cqxy.universal.manager.AccessoryManager;
import com.artfess.cqxy.universal.model.Accessory;
import com.artfess.cqxy.utils.BizUtils;
import com.artfess.poi.util.ExcelUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.Assert;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 过程管理 - 安全管理(BizSecurityManage)表服务实现类
 *
 * @author 黎沐华
 * @since 2022-03-04 15:40:47
 */
@Service
public class SecurityManageManagerImpl extends BaseManagerImpl<SecurityManageDao, SecurityManage> implements SecurityManageManager {

    @Autowired
    private AccessoryManager accessoryManager;

    @Autowired
    private SystemConfigFeignService scfs;

    @Autowired
    private ProjectManagementManager pmm;

    @Autowired
    private BaseContext baseContext;

    @Autowired
    private GlobalRetrievalManager grm;

    @Override
    public boolean saveOrUpdate(SecurityManage entity) {
        boolean save = StringUtils.isEmpty(entity.getId());
        String code = scfs.getNextIdByAlias("gcgl_aqgl");
        entity.setSecurityInspectCode(code.substring(StringUtils.lastOrdinalIndexOf(code, "\"", 2) + 1, code.lastIndexOf("\"")));
        boolean savedMain = super.saveOrUpdate(entity);
        // 处理附件信息
        List<Accessory> flag = entity.getAccessoryInfo();//处理空指针
        List<Accessory> accessoryList = null == flag ? new ArrayList<>() : flag;
        for (Accessory ele : accessoryList) {
            ele.setSourceId(entity.getId());
            ele.setProjectId(entity.getProjectId());
            ele.setDirectory(ProjectStatusEnum.eleven.getCode());
            ele.setGroup("SecurityManage");
            ele.setNode(ProjectStatusEnum.eleven.getCode());
            ele.setCreateBy(baseContext.getCurrentUserId());
            ele.setCreateName(baseContext.getCurrentUserName());
            ele.setCreateTime(LocalDateTime.now());
        }
        // 先清空该ID下的所有附件信息再添加
        accessoryManager.removeBySourceId(entity.getId());
        // 如果没有附件则返回true，不进入添加
        boolean saveAcc = accessoryList.size() == 0 || accessoryManager.saveAccess(accessoryList);
        //更新项目状态
        pmm.updateStatusById(entity.getProjectId(), Integer.valueOf(ProjectStatusEnum.eleven.getCode()));
        // 同步到检索表
        GlobalRetrieval globalRetrieval= grm.getByBizId(entity.getId());
        handleRetrieval(save || BeanUtils.isEmpty(globalRetrieval) ?new GlobalRetrieval():globalRetrieval,entity);

        return savedMain && saveAcc;
    }

    private void handleRetrieval(GlobalRetrieval globalRetrieval, SecurityManage entity){
        ProjectManagement projectManagement = pmm.getById(entity.getProjectId());
        globalRetrieval.setProjectId(entity.getProjectId());
        if(null != projectManagement){
            globalRetrieval.setProjectName(projectManagement.getProjectName());
            globalRetrieval.setPersonCharge(projectManagement.getProjectManager());
        }
        globalRetrieval.setArchivesType(1);
        globalRetrieval.setBizDataId(entity.getId());
        globalRetrieval.setFunctionCode(FunctionEnum.ninteen.getCode());
        globalRetrieval.setFunctionName(FunctionEnum.ninteen.getName());
        globalRetrieval.setBizTableName(FunctionEnum.ninteen.getTableName());
        globalRetrieval.setDetailsRoteUrl(FunctionEnum.ninteen.getTableRoteUrl());
        globalRetrieval.setTableRoteUrl(FunctionEnum.ninteen.getTableRoteUrl());
        globalRetrieval.setTableApiUrl(FunctionEnum.ninteen.getTableApiUrl());
        globalRetrieval.setDetailsApiUrl(FunctionEnum.ninteen.getDetailsApiUrl());
        globalRetrieval.setFunctionPath(FunctionEnum.ninteen.getFunctionPath());
        globalRetrieval.setDocumentNumber(entity.getSecurityInspectCode());
        globalRetrieval.setSearchTitle(entity.getSecurityInspectCode()+"_"+entity.getProjectScale()+"_"+entity.getImageProgress()+"_"+
                entity.getInspectUserName()+"_"+entity.getBaseSituation()+"_"+entity.getCheckSituation()+"_"+entity.getChangeContractName()+"_"+
                entity.getReexaminationSituation()+"_"+entity.getReexaminationUser()+"_"+entity.getRemarks());
        grm.saveOrUpdate(globalRetrieval);
    }

    @Override
    public boolean deleteByIds(List<String> ids) {
        // 同步删除检索表中的信息
        for(String ele:ids){
            grm.remove(1,ele);
        }
        return removeByIds(ids);
    }

    @Override
    public SecurityManage getById(String id) {
        SecurityManage result = baseMapper.getById(id);
        result.setAccessoryInfo(accessoryManager.getAccessoryBySourceId(id));
        return result;
    }

    @Override
    public PageList<SecurityManage> queryAllByPage(QueryFilter<SecurityManage> queryFilter) {
        queryFilter.addFilter("bsm.IS_DELE_", "0", QueryOP.EQUAL);
        IPage<SecurityManage> result =
                baseMapper.queryAllByPage(
                        convert2IPage(queryFilter.getPageBean()),
                        convert2Wrapper(queryFilter, currentModelClass()));
        // 附件信息处理
        List<SecurityManage> records = result.getRecords();
        for (SecurityManage ele : records) {
            ele.setAccessoryInfo(accessoryManager.getAccessoryBySourceId(ele.getId()));
        }

        return new PageList<>(result);
    }

    @Override
    public void importExcelData(MultipartFile file, String projectId
                                /**, String inspectUserId, String inspectUserName**/) {
        // 去掉项目ID的验证
//        Assert.notNull(projectId,"项目ID不能为空");
        try(InputStream inputStream = file.getInputStream();) {
            // 获取数据
            List<SecurityManage> data = ExcelImportUtil.importExcel(inputStream,SecurityManage.class,new ImportParams());
            for(SecurityManage ele:data){
                ele.setProjectId(projectId);
                String code = scfs.getNextIdByAlias("gcgl_aqgl");
                ele.setSecurityInspectCode(code.substring(StringUtils.lastOrdinalIndexOf(code, "\"", 2) + 1, code.lastIndexOf("\"")));
                // 保存数据 & 同步到检索表
                save(ele);
                handleRetrieval(new GlobalRetrieval(),ele);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void exportDataToExcel(QueryFilter<SecurityManage> queryFilter, HttpServletResponse response) throws IOException {
        String fileName = "过程管理-安全管理-导出结果";

        // 获取数据
        BizUtils.handleFilter(queryFilter, "bsm", false);
        List<SecurityManage> data = baseMapper.queryAllByPage(
                        convert2IPage(new PageBean(0, -1, false)),
                        convert2Wrapper(queryFilter, currentModelClass())).
                getRecords();
        if(null==data||data.size()==0){
            throw new RuntimeException("没有要导出的的数据！");
        }

        // EasyPoi 导出参数、样式、表格格式设置
        ExportParams exportParams = BizUtils.getExportParams(fileName);
        fileName += ".xlsx";

        // 导出下载excel文件
        Workbook workbook = ExcelExportUtil.exportExcel(exportParams, SecurityManage.class, data);
        ExcelUtil.downloadExcel(workbook, fileName, response);
    }

    @Override
    public void updateProjectIdByProiectId(String oldProjectIds, String newProjectId) {
        UpdateWrapper<SecurityManage> wrapper = new UpdateWrapper<SecurityManage>()
                .set(StringUtils.isNotBlank(newProjectId), "PROJECT_ID_", newProjectId)
                .in("PROJECT_ID_", Arrays.asList(oldProjectIds.split(",")));
        this.update(wrapper);
    }

}

